<?php
namespace Planejamento\Entities;

use Geral\Util\DateUtil;
use Setforms2\Shared\Registry;

class Destsrvcli extends Base\Destsrvcli
{
    public static function insere
    (
        $nrorg, $cdfilial, $cliente, $servfili, $destfili,
        $qtcoestcsseg, $qtcoestcster, $qtcoestcsqua, $qtcoestcsqui,
        $qtcoestcssex, $qtcoestcssab, $qtcoestcsdom, $qtcoestcsfer,
        $dtinclusao, $nrorginclusao, $cdoperinclusao
    ) {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            $destsrvcli = new Destsrvcli;
            //
            $destsrvcli->setNrorg($nrorg);
            $destsrvcli->setCdfilial($cdfilial);
            $destsrvcli->setCliente($cliente);
            $destsrvcli->setServfili($servfili);
            $destsrvcli->setDestfili($destfili);
            //
            $destsrvcli->setQtcoestcsseg($qtcoestcsseg);
            $destsrvcli->setQtcoestcster($qtcoestcster);
            $destsrvcli->setQtcoestcsqua($qtcoestcsqua);
            $destsrvcli->setQtcoestcsqui($qtcoestcsqui);
            $destsrvcli->setQtcoestcssex($qtcoestcssex);
            $destsrvcli->setQtcoestcssab($qtcoestcssab);
            $destsrvcli->setQtcoestcsdom($qtcoestcsdom);
            $destsrvcli->setQtcoestcsfer($qtcoestcsfer);
            //
            $destsrvcli->setDtinclusao($dtinclusao);
            $destsrvcli->setDtultatu($dtinclusao);
            $destsrvcli->setNrorginclusao($nrorginclusao);
            $destsrvcli->setNrorgultatu($nrorginclusao);
            $destsrvcli->setCdoperinclusao($cdoperinclusao);
            $destsrvcli->setCdoperultatu($cdoperinclusao);
            //
            $destsrvcli->persist();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function atualiza
    (
        $destsrvcli, $destfili,
        $qtcoestcsseg, $qtcoestcster, $qtcoestcsqua, $qtcoestcsqui,
        $qtcoestcssex, $qtcoestcssab, $qtcoestcsdom, $qtcoestcsfer,
        $dtultatu, $nrorgultatu, $cdoperultatu
    ) {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            $destsrvcli->setDestfili($destfili);
            //
            $destsrvcli->setQtcoestcsseg($qtcoestcsseg);
            $destsrvcli->setQtcoestcster($qtcoestcster);
            $destsrvcli->setQtcoestcsqua($qtcoestcsqua);
            $destsrvcli->setQtcoestcsqui($qtcoestcsqui);
            $destsrvcli->setQtcoestcssex($qtcoestcssex);
            $destsrvcli->setQtcoestcssab($qtcoestcssab);
            $destsrvcli->setQtcoestcsdom($qtcoestcsdom);
            $destsrvcli->setQtcoestcsfer($qtcoestcsfer);
            //
            $destsrvcli->setDtultatu($dtultatu);
            $destsrvcli->setNrorgultatu($nrorgultatu);
            $destsrvcli->setCdoperultatu($cdoperultatu);
            //
            $destsrvcli->persist();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    /**
     * Deleta registros da tabela DESTSRVCLI
     * Busca todos os registros de um mesmo cliente e deleta todos eles.
     * Filtra-se por NRORG, CDFILIAL, CDSERVFILI e CDCLIENTE.
     *
     * @param $nrorg
     * @param $cdfilial
     * @param $cdservfili
     * @param $cdcliente
     *
     * @return null
     * @throws \Exception
     */
    public static function deletaPorCliente(
        $nrorg, $cdfilial, $cdservfili, $cdcliente
    ) {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();
        //
        $registros = self::getObjectsByWhere(
            "NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ? AND CDCLIENTE = ?",
            array($nrorg, $cdfilial, $cdservfili, $cdcliente)
        );
        //
        try {
            foreach ($registros as $registro) {
                if ($registro instanceof self) {
                    $registro->delete();
                }
            }
            $connection->flush();
            $connection->commit();
        } catch(\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
}