/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CONFIGPREF                                                 */
/* Tabela : CONFIGPREF                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 01/09/2004 - Luiz Otvio de Souza                                      */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CONFIGPREF
BEFORE INSERT OR UPDATE OR DELETE
ON CONFIGPREF FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCPRE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.QTPAXPREFIXO,0) <> NVL(:NEW.QTPAXPREFIXO,0)) OR
         (NVL(:OLD.CDAGRDEL,0) <> NVL(:NEW.CDAGRDEL,0)) OR
         (NVL(:OLD.QTPAXSBYPREF,0) <> NVL(:NEW.QTPAXSBYPREF,0)) THEN
         :NEW.DTULTATUCPRE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CONFIGPREF',:OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDCIA='||:OLD.CDCIA||';SGPREFIXO='||:OLD.SGPREFIXO||';CDCLASSE='||:OLD.CDCLASSE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CONFIGPREF MODIFY DTULTATUCPRE DEFAULT SYSDATE
/

